# bsh.tcl --
#
#	Tcl implementations of BSH utilities.
#
# Copyright (c) 2000 by Satoshi Imai

package provide bsh 1.0

namespace eval ::bsh {
    variable _list {}
    variable IFS " \t\n"
}

proc ::bsh::set {args} {
    variable _list
    variable IFS

    if {[llength $args] == 0} {
	global env
	parray env
	return
    }
    ::set _list {}
    foreach arg $args {
	if {$IFS != ""} {
	    lappend _list [split $arg $IFS]
	} else {
	    lappend _list $arg
	}
    }
    uplevel 1 "
	global argv0
	if [info exists ::argv0] {
	    ::set 0 \$::argv0
	}
	::set 1 \[lindex \"$_list\" 0\]
	::set 2 \[lindex \"$_list\" 1\]
	::set 3 \[lindex \"$_list\" 2\]
	::set 4 \[lindex \"$_list\" 3\]
	::set 5 \[lindex \"$_list\" 4\]
	::set 6 \[lindex \"$_list\" 5\]
	::set 7 \[lindex \"$_list\" 6\]
	::set 8 \[lindex \"$_list\" 7\]
	::set 9 \[lindex \"$_list\" 8\]
	::set # [llength $_list]
	::set * \[concat $_list\]
	::set @ \"$_list\"
	::set _ \[lindex \"$_list\" end\]
    "
    return
}

proc ::bsh::shift {{count 1}} {
    variable _list

    if {[llength $_list] < $count} {
	error {shift: shift count must be <= ${#}}
    }
    ::set _list [lrange $_list $count end]
    uplevel 1 "
	global argv0
	if [info exists ::argv0] {
	    ::set 0 \$::argv0
	}
	::set 1 \[lindex \"$_list\" 0\]
	::set 2 \[lindex \"$_list\" 1\]
	::set 3 \[lindex \"$_list\" 2\]
	::set 4 \[lindex \"$_list\" 3\]
	::set 5 \[lindex \"$_list\" 4\]
	::set 6 \[lindex \"$_list\" 5\]
	::set 7 \[lindex \"$_list\" 6\]
	::set 8 \[lindex \"$_list\" 7\]
	::set 9 \[lindex \"$_list\" 8\]
	::set # [llength $_list]
	::set * \[concat $_list\]
	::set @ \"$_list\"
	::set _ \[lindex \"$_list\" end\]
    "
    return
}
